[![Angel 3 Framework](./logo3.png)](https://github.com/dukefirehawk/angel)

[![Version](https://img.shields.io/badge/pub-v4.0.0-brightgreen)](https://pub.dartlang.org/packages/angel3_framework)
[![Null Safety](https://img.shields.io/badge/null-safety-brightgreen)](https://dart.dev/null-safety)
[![Gitter](https://img.shields.io/gitter/room/angel_dart/discussion)](https://gitter.im/angel_dart/discussion)

[![License](https://img.shields.io/github/license/dukefirehawk/angel)](https://github.com/dukefirehawk/boilerplates/blob/angel3-orm/LICENSE)

**A polished, production-ready backend framework in Dart.**

*Note: This repo is an application boilerplate ,and not the underlying framework library.*

-----
## About
Angel is a full-stack Web framework in Dart. It aims to
streamline development by providing many common features
out-of-the-box in a consistent manner.

With features like the following, Angel is the all-in-one framework you should choose to build your next project:
* [GraphQL Support](https://github.com/dukefirehawk/angel/tree/master/packages/graphql)
* [PostgreSQL ORM](https://github.com/dukefirehawk/angel/tree/master/packages/orm)
* [Dependency Injection](https://angel3-docs.dukefirehawk.com/guides/dependency-injection)
* And [much more](https://github.com/dukefirehawk/angel)...

## Installation & Setup

Once you have [Dart](https://dart.dev/get-dart) installed, bootstrapping a project is as simple as running a few shell commands:

Install the [Angel3 CLI](https://github.com/dukefirehawk/angel3-cli):

```bash
pub global activate angel_cli
```

Bootstrap a project:

```bash
angel init hello
```

You can even have your server run and be *hot-reloaded* on file changes:

```bash
dart --observe bin/dev.dart
```

Next, check out the [detailed documentation](https://angel3-docs.dukefirehawk.com/guides) to learn to flesh out your project.

## Examples and Documentation
Visit the [documentation](https://angel3-docs.dukefirehawk.com/guides)
for dozens of guides and resources, including video tutorials,
to get up and running as quickly as possible with Angel.

Examples and complete projects can be found
[here](https://github.com/dukefirehawk/angel3-examples/tree/master/docs_examples/getting_started).


You can also view the [API Documentation](https://pub.dev/documentation/angel3_framework/latest/).

There is also an [Awesome Angel :fire:](https://github.com/dukefirehawk/angel3-awesome) list.

